/*
 * Copyright (c) 2019 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License")
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#ifndef __BM_DN_UTIL_H__
#define __BM_DN_UTIL_H__

#include <stdlib.h>
#include <tizen.h>
#include <glib.h>

#ifdef __cplusplus
extern "C" {
#endif

#define NAME		"dn_plugin"
#define AUTHOR		"SAMSUNG"
#define VERSION		"0.1"

#define BUFFER_SZ	200

#define BMP_RETURN_VAL(eval, expr, ret_val, X) \
	if (!(eval)) { \
		expr; \
		return ret_val; \
	} else {}

#define BMP_SNPRINTF(dest, size, format, arg...) \
	do { \
		snprintf(dest, size-1, format, ##arg); \
	} while (0)

#define BMP_MEMSET(dest, value, size) \
	do { \
		memset(dest, value, size); \
	} while (0)

#define BMP_CATCH_ERROR(eval, expr, error_val, X) \
	if (!(eval)) { \
		expr; \
		error_code = (error_val); \
		goto CATCH; \
	} else {}

#define BMP_CATCH_ERROR_P(eval, expr, error_val, X) \
	if (!(eval)) { \
		expr; \
		*error_code = (error_val); \
		goto CATCH; \
	} else { }

#define BMP_FREE(ptr)ptr \
	if (ptr != NULL) { \
		free(ptr); \
		ptr = NULL; \
	} \

#define BMP_GFREE(ptr)ptr \
	if (ptr != NULL) { \
		g_free(ptr); \
		ptr = NULL; \
	} \

#ifdef __cplusplus
}
#endif

#endif /* __BM_DN_UTIL_H__ */


